#last edited dec1115
#Brian Campbell-Deem cmpblld2
#MATH198
#Physible pt. 4

from visual import * 
from visual.graph import *
from random import random
import numpy.random as rand

a = 5.29177211E-11 #magnitude of bohr radius




scene = display()
scene.title = "Hydrogen Ground State"
scene.range=100 				#SCENE SCALED SO THAT 10 UNITs = a
scene.background=color.white
scene.autoscale=False
#scene.fullscreen=true			#kind of buggy

retained=4000		#how many points to show at once (use more if at higher resolution/window size)
dt=1.0/retained

pointsArray=[]
pointsCounter=0
numCount=0


for i in arange(0,retained):	#initialize array to size of retained
	pointsArray.append(points(pos=(0,0,0), size=1.5, color=color.blue))


mesh1 = box(pos=(50,50,0), length=0.5, width=100, height=0.5)
mesh2 = box(pos=(-50,50,0), length=0.5, width=100, height=0.5)
mesh3 = box(pos=(50,-50,0), length=0.5, width=100, height=0.5)
mesh4 = box(pos=(-50,-50,0), length=0.5, width=100, height=0.5)

mesh5 = box(pos=(50,0,50), length=0.5, width=0.5, height=100)
mesh6 = box(pos=(-50,0,50), length=0.5, width=0.5, height=100)
mesh7 = box(pos=(50,0,-50), length=0.5, width=0.5, height=100)
mesh8 = box(pos=(-50,0,-50), length=0.5, width=0.5, height=100)

mesh5 = box(pos=(0,50,50), length=100, width=0.5, height=0.5)
mesh6 = box(pos=(0,-50,50), length=100, width=0.5, height=0.5)
mesh7 = box(pos=(0,50,-50), length=100, width=0.5, height=0.5)
mesh8 = box(pos=(0,-50,-50), length=100, width=0.5, height=0.5)

proton = sphere(pos=(0,0,0), radius=0.5, color=color.red) 	# r_p=a/20: gross exaggeration (r_p much, much smaller)
#electron = sphere(pos=(5,0,0), radius=0.001, color=color.blue, make_trail=true, trail_type="points", retain=retained) # r_e=a/1000. laughably overestimated
#above not necessary with new pointsArray!
bohr_shell = sphere(pos=(0,0,0), radius=10, color=color.blue, opacity=0.04) 	#shell with r=a, the most probable radius
x_rand = 0
y_rand = 0
z_rand = 0


					#CURRENT ISSUES:
					#	-new pointsArray method still has sizing issues, although much more manageable.
					#	-there seems to be a favored axis (z), but distribution should be spherically isometric.

g1 = gdisplay(x=scene.width, title="Ground State Graphs", xtitle="Bohr radii", xmin=-1, xmax=10)
fn100 = gcurve(color=color.red)
probDensity = gcurve(color=color.cyan)
probabilityG = gcurve(color=color.blue)

label(display=g1.display, pos=(3.5, 0.5), text="Wavefunction", color=color.red)
label(display=g1.display, pos=(5.8, 0.5), text="Probability Density", color=color.cyan)
label(display=g1.display, pos=(7.9, 0.5), text="Probability", color=color.blue)

a=1.0 # for readability of graph
for r in arange(0.0,10.0*a,a/100): # theoretical prediction for 100 state
    fn100.plot(pos=(r, (exp(-r/a)) * 1.0/(a*sqrt(pi*a)) )) 					#wavefunction
    probDensity.plot(pos=(r, (exp(-2*r/a)) * 1.0/pi * pow((1.0/a), 3) ))
    probabilityG.plot(pos=(r, 4/(a**3) * exp(-2*r/a) * (r**2)  ))			#P(r) = r^2 * (4/a^3) * e^(-2r/a) 
    																		#isotropic in phi, theta for 100 state


while(true):
	dt=1.0/retained
	rate(2.0/dt)		#program run rate (generally should be (2*retained) for smoothness)

	seed=100*random() 					#probability distribution for radius measurement
	
	if(seed<=0.099):					#found between   r_p and  a/10: 0.099%
		r_rand=0.5 + 0.5*random()
	elif(seed-0.099<=0.678):			#found between  a/10 and 2a/10: 0.678%
		r_rand=1 + random()
	elif(seed-0.777<=1.519):			#found between 2a/10 and 3a/10: 1.519%
		r_rand=2 + random()
	elif(seed-2.296<=2.431):			#found between 3a/10 and 4a/10: 2.431%
		r_rand=3 + random()
	elif(seed-4.727<=3.288):			#found between 4a/10 and 5a/10: 3.288%
		r_rand=4 + random()
	elif(seed-8.015<=4.021):			#found between 5a/10 and 6a/10: 4.021%
		r_rand=5 + random()
	elif(seed-12.036<=4.599):			#found between 6a/10 and 7a/10: 4.599%
		r_rand=6 + random()
	elif(seed-16.265<=5.014):			#found between 7a/10 and 8a/10: 5.014%
		r_rand=7 + random()
	elif(seed-21.649<=5.274):			#found between 8a/10 and 9a/10: 5.274%
		r_rand=8 + random()
	elif(seed-26.923<=5.395):			#found between 9a/10 and 10a/10: 5.395%
		r_rand=9 + random()
	elif(seed-32.318<=5.396):			#found between 10a/10 and 11a/10: 5.396%
		r_rand=10 + random()
	elif(seed-37.714<=5.301):			#found between 11a/10 and 12a/10: 5.301%
		r_rand=11 + random()
	elif(seed-43.015<=5.128):			#found between 12a/10 and 13a/10: 5.128%
		r_rand=12 + random()
	elif(seed-48.143<=4.898):			#found between 13a/10 and 14a/10: 4.898%
		r_rand=13 + random()
	elif(seed-53.041<=4.626):			#found between 14a/10 and 15a/10: 4.626%
		r_rand=14 + random()
	elif(seed-57.667<=4.329):			#found between 15a/10 and 16a/10: 4.329%
		r_rand=15 + random()
	elif(seed-61.996<=4.016):			#found between 16a/10 and 17a/10: 4.016%
		r_rand=16 + random()
	elif(seed-66.012<=3.699):			#found between 17a/10 and 18a/10: 3.699%
		r_rand=17 + random()
	elif(seed-69.711<=3.385):			#found between 18a/10 and 19a/10: 3.385%
		r_rand=18 + random()
	elif(seed-73.096<=3.079):			#found between 19a/10 and 20a/10: 3.079%
		r_rand=19 + random()
	elif(seed-76.175<=2.787):			#found between 20a/10 and 21a/10: 2.787%
		r_rand=20 + random()
	elif(seed-78.962<=2.510):			#found between 21a/10 and 22a/10: 2.510%
		r_rand=21 + random()
	elif(seed-81.472<=2.250):			#found between 22a/10 and 23a/10: 2.250%
		r_rand=22 + random()
	elif(seed-83.722<=2.010):			#found between 23a/10 and 24a/10: 2.010%
		r_rand=23 + random()
	elif(seed-85.732<=1.789):			#found between 24a/10 and 25a/10: 1.789%
		r_rand=24 + random()
	elif(seed-87.521<=1.587):			#found between 25a/10 and 26a/10: 1.587%
		r_rand=25 + random()
	elif(seed-89.108<=1.403):			#found between 26a/10 and 27a/10: 1.403%
		r_rand=26 + random()
	elif(seed-90.511<=1.237):			#found between 27a/10 and 28a/10: 1.237%
		r_rand=27 + random()
	elif(seed-91.748<=1.088):			#found between 28a/10 and 29a/10: 1.088%
		r_rand=28 + random()
	elif(seed-92.836<=0.954):			#found between 29a/10 and 30a/10: 0.954%
		r_rand=29 + random()
	elif(seed-93.790<=1.565):			#found between 30a/10 and 32a/10: 1.565%  NOTE DELTA R CHANGE IN APPROXIMATION
		r_rand=30 + 2*random()
	elif(seed-95.355<=1.189):			#found between 32a/10 and 34a/10: 1.189%
		r_rand=32 + 2*random()
	elif(seed-96.544<=0.896):			#found between 34a/10 and 36a/10: 0.896%
		r_rand=34 + 2*random()
	elif(seed-97.440<=1.172):			#found between 36a/10 and 40a/10: 1.172%  NOTE DELTA R CHANGE IN APPROXIMATION
		r_rand=36 + 4*random()
	elif(seed-98.612<=0.752):			#found between 40a/10 and 45a/19: 0.752%   ""   ""	 ""  ""	  ""	  ""
		r_rand=40 + 5*random()
	elif(seed-99.364<=0.346):			#found between 45a/10 and 50a/10: 0.346%
		r_rand=45 + 5*random()
	#									----------------------------------------
	#									    	TOTAL PROBABILITY: 99.71
	else:
		r_rand=random()*50	#probability cleanup: 0.29%	to be found some equally random pt. between proton and 5a.					
										#in reality the remaining prob. would be outside of 5a or inside proton (mathematically)...
										#but I give even distribution for the remaining 0.29% to keep simulation between r_p and 5a.


	neg = -1
	if(random()<=0.5):
		neg=1

	phi_rand =  pi * random() * neg
	theta_rand = pi * random()
	#theta_rand=random()*pi/rand.random_integers(4,12)            # P orbitals possibly
	#if(random()<0.5):
	#	theta_rand=pi-theta_rand
	
	#electron.pos=(r_rand*math.sin(theta_rand)*math.cos(phi_rand), r_rand*(math.sin(phi_rand)*math.sin(theta_rand)), r_rand*math.cos(theta_rand))
	pointsArray[pointsCounter].pos=(r_rand*sin(theta_rand)*cos(phi_rand), r_rand*sin(phi_rand)*sin(theta_rand), r_rand*cos(theta_rand))
	pointsCounter+=1
	if(pointsCounter>=retained):
		pointsCounter=0
	

	#p_avg=((p_avg*numCount)+phi_rand)/(numCount+1)
	#t_avg=((t_avg*numCount)+theta_rand)/(numCount+1)
	#x_avg=sin(t_avg)*cos(p_avg)
	#y_avg=(sin(p_avg)*sin(t_avg))
	#z_avg=cos(t_avg)
	#A.axis=(50*x_avg, 50*y_avg, 50*z_avg)
	#numCount+=1

	#print x_avg, " and ", y_avg, " and ", z_avg

	scene.forward = scene.forward*cos(dt/2) -  sin(dt/2)*scene.up.cross(scene.forward) 

	
	




#for r in arange(0.0,10.0*a,a/100): # theoretical prediction
#    fn200.plot(pos=(r, ((2-(r/a))*exp(-r/(2*a))*(1/(4*a*(sqrt(2*pi*a)))))**2 ))